import { defineComponent as z, ref as G, onMounted as H, resolveComponent as v, createElementBlock as f, openBlock as c, createVNode as o, withCtx as p, createCommentVNode as b, createElementVNode as j, unref as S, Fragment as w, renderList as q, createBlock as K } from "vue";
import { Plus as y, Delete as Q } from "@element-plus/icons-vue";
const W = { class: "jsf-json-schema-form" }, X = {
  key: 0,
  class: "jsf-top-button"
}, Y = { class: "jsf-schema-container" }, Z = {
  key: 0,
  class: "jsf-empty-state"
}, N = { class: "jsf-property-fields" }, ee = { class: "jsf-action-buttons" }, te = {
  key: 0,
  class: "jsf-array-items"
}, le = { class: "jsf-property-fields" }, oe = {
  key: 0,
  class: "jsf-nested-schema"
}, se = {
  key: 1,
  class: "jsf-nested-schema"
}, ne = /* @__PURE__ */ z({
  name: "JsonSchemaForm",
  __name: "main",
  props: {
    modelValue: {},
    isRootLevel: { type: Boolean, default: !0 }
  },
  emits: ["update:model-value"],
  setup(h, { emit: g }) {
    const a = h, i = g, d = G({}), F = ["string", "number", "integer", "object", "array", "boolean", "null"];
    H(() => {
      d.value = Object.keys(a.modelValue.properties || {}).reduce((l, t) => (l[t] = t, l), {});
    });
    const R = (l) => {
      var t;
      return ((t = a.modelValue.required) == null ? void 0 : t.includes(l)) || !1;
    }, U = (l) => {
      var r;
      const t = { ...a.modelValue };
      let e;
      l && ((r = t.properties) != null && r[l]) ? (t.properties[l].properties || (t.properties[l].properties = {}), e = t.properties[l].properties) : (t.properties || (t.properties = {}), e = t.properties);
      const n = `property${Object.keys(e).length + 1}`;
      e[n] = {
        type: "string",
        title: ""
      }, d.value[n] = n, i("update:model-value", t);
    }, A = (l) => {
      var r;
      const t = { ...a.modelValue };
      if (!t.properties) return;
      const { [l]: e, ...n } = t.properties;
      t.properties = n, t.required = ((r = t.required) == null ? void 0 : r.filter((_) => _ !== l)) || [], delete d.value[l], i("update:model-value", t);
    }, I = (l) => {
      var _;
      const t = d.value[l];
      if (l === t || t.trim() === "") {
        d.value[l] = l;
        return;
      }
      const e = { ...a.modelValue };
      if (!e.properties) return;
      const { [l]: n, ...r } = e.properties;
      e.properties = {
        ...r,
        [t]: n
      }, e.required = (_ = e.required) == null ? void 0 : _.map(
        (k) => k === l ? t : k
      ), delete d.value[l], d.value[t] = t, i("update:model-value", e);
    }, P = (l, t) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [l]: {
          ...e.properties[l],
          type: t,
          ...t === "object" && { properties: {} },
          ...t === "array" && {
            items: {
              type: "string"
            }
          }
        }
      }, i("update:model-value", e));
    }, T = (l, t) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [l]: {
          ...e.properties[l],
          title: t
        }
      }, i("update:model-value", e));
    }, L = (l, t) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [l]: t
      }, i("update:model-value", e));
    }, $ = (l, t) => {
      const e = { ...a.modelValue }, n = new Set(e.required || []);
      t ? n.add(l) : n.delete(l), e.required = Array.from(n), i("update:model-value", e);
    }, E = (l, t) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [l]: {
          ...e.properties[l],
          items: {
            ...e.properties[l].items,
            type: t,
            ...t === "object" && { properties: {} }
          }
        }
      }, i("update:model-value", e));
    }, D = (l, t) => {
      const e = { ...a.modelValue };
      if (!e.properties) return;
      const n = e.properties[l];
      n.items ? n.items = {
        ...n.items,
        title: t
      } : n.items = {
        type: "string",
        title: t
      }, e.properties = {
        ...e.properties,
        [l]: n
      }, i("update:model-value", e);
    }, M = (l, t) => {
      const e = { ...a.modelValue };
      e.properties && (e.properties = {
        ...e.properties,
        [l]: {
          ...e.properties[l],
          items: t
        }
      }, i("update:model-value", e));
    };
    return (l, t) => {
      const e = v("el-button"), n = v("el-input"), r = v("el-form-item"), _ = v("el-checkbox"), k = v("el-option"), B = v("el-select"), J = v("JsonSchemaForm"), x = v("el-form");
      return c(), f("div", W, [
        o(x, { ref: "formRef" }, {
          default: p(() => [
            l.isRootLevel && l.modelValue.properties && Object.keys(l.modelValue.properties).length > 0 ? (c(), f("div", X, [
              o(e, {
                type: "primary",
                icon: S(y),
                circle: "",
                onClick: t[0] || (t[0] = () => U())
              }, null, 8, ["icon"])
            ])) : b("", !0),
            j("div", Y, [
              !l.modelValue.properties || Object.keys(l.modelValue.properties).length === 0 ? (c(), f("div", Z, [
                o(e, {
                  type: "primary",
                  icon: S(y),
                  circle: "",
                  onClick: t[1] || (t[1] = () => U())
                }, null, 8, ["icon"])
              ])) : b("", !0),
              (c(!0), f(w, null, q(l.modelValue.properties, (m, u) => {
                var O;
                return c(), f("div", {
                  key: u,
                  class: "jsf-property-row"
                }, [
                  j("div", N, [
                    o(r, { label: "属性" }, {
                      default: p(() => [
                        o(n, {
                          modelValue: d.value[u],
                          "onUpdate:modelValue": (s) => d.value[u] = s,
                          onBlur: (s) => I(u)
                        }, null, 8, ["modelValue", "onUpdate:modelValue", "onBlur"])
                      ]),
                      _: 2
                    }, 1024),
                    o(r, { label: "必填" }, {
                      default: p(() => [
                        o(_, {
                          "model-value": R(u),
                          "onUpdate:modelValue": (s) => $(u, s)
                        }, null, 8, ["model-value", "onUpdate:modelValue"])
                      ]),
                      _: 2
                    }, 1024),
                    o(r, { label: "类型" }, {
                      default: p(() => [
                        o(B, {
                          "model-value": m.type,
                          "onUpdate:modelValue": (s) => P(u, s)
                        }, {
                          default: p(() => [
                            (c(), f(w, null, q(F, (s) => o(k, {
                              key: s,
                              label: s,
                              value: s
                            }, null, 8, ["label", "value"])), 64))
                          ]),
                          _: 2
                        }, 1032, ["model-value", "onUpdate:modelValue"])
                      ]),
                      _: 2
                    }, 1024),
                    o(r, { label: "标题" }, {
                      default: p(() => [
                        o(n, {
                          "model-value": m.title,
                          "onUpdate:modelValue": (s) => T(u, s)
                        }, null, 8, ["model-value", "onUpdate:modelValue"])
                      ]),
                      _: 2
                    }, 1024),
                    j("div", ee, [
                      o(e, {
                        type: "danger",
                        icon: S(Q),
                        circle: "",
                        onClick: (s) => A(u)
                      }, null, 8, ["icon", "onClick"]),
                      m.type === "object" ? (c(), K(e, {
                        key: 0,
                        type: "primary",
                        icon: S(y),
                        circle: "",
                        onClick: () => U(u)
                      }, null, 8, ["icon", "onClick"])) : b("", !0)
                    ])
                  ]),
                  m.type === "array" ? (c(), f("div", te, [
                    j("div", le, [
                      o(r, { label: "数组项" }, {
                        default: p(() => [
                          o(n, {
                            value: "items",
                            disabled: ""
                          })
                        ]),
                        _: 1
                      }),
                      o(r, { label: "必填" }, {
                        default: p(() => [
                          o(_, { disabled: "" })
                        ]),
                        _: 1
                      }),
                      o(r, { label: "类型" }, {
                        default: p(() => {
                          var s;
                          return [
                            o(B, {
                              "model-value": (s = m.items) == null ? void 0 : s.type,
                              "onUpdate:modelValue": (V) => E(u, V)
                            }, {
                              default: p(() => [
                                (c(), f(w, null, q(F, (V) => o(k, {
                                  key: V,
                                  label: V,
                                  value: V
                                }, null, 8, ["label", "value"])), 64))
                              ]),
                              _: 2
                            }, 1032, ["model-value", "onUpdate:modelValue"])
                          ];
                        }),
                        _: 2
                      }, 1024),
                      o(r, { label: "标题" }, {
                        default: p(() => {
                          var s;
                          return [
                            o(n, {
                              "model-value": (s = m.items) == null ? void 0 : s.title,
                              "onUpdate:modelValue": (V) => D(u, V)
                            }, null, 8, ["model-value", "onUpdate:modelValue"])
                          ];
                        }),
                        _: 2
                      }, 1024)
                    ]),
                    ((O = m.items) == null ? void 0 : O.type) === "object" ? (c(), f("div", oe, [
                      o(J, {
                        "model-value": m.items,
                        "onUpdate:modelValue": (s) => M(u, s),
                        "is-root-level": !1
                      }, null, 8, ["model-value", "onUpdate:modelValue"])
                    ])) : b("", !0)
                  ])) : b("", !0),
                  m.type === "object" ? (c(), f("div", se, [
                    o(J, {
                      "model-value": m,
                      "onUpdate:modelValue": (s) => L(u, s),
                      "is-root-level": !1
                    }, null, 8, ["model-value", "onUpdate:modelValue"])
                  ])) : b("", !0)
                ]);
              }), 128))
            ])
          ]),
          _: 1
        }, 512)
      ]);
    };
  }
}), re = (h, g) => {
  const a = h.__vccOpts || h;
  for (const [i, d] of g)
    a[i] = d;
  return a;
}, C = /* @__PURE__ */ re(ne, [["__scopeId", "data-v-2b781afb"]]);
C.name = "JsonSchemaForm";
const ae = (h) => {
  h.component("JsonSchemaForm", C);
}, de = {
  install: ae,
  // Export the component directly for tree-shaking
  component: C
};
export {
  C as JsonSchemaForm,
  de as default,
  ae as install
};
